#include "demucc.h"

struct mmlbuf* mmlbuf_new()
{
    struct mmlbuf* mmlbuf;
    mmlbuf = malloc(sizeof(struct mmlbuf));
    mmlbuf_reset(mmlbuf);
    return mmlbuf;
}

void mmlbuf_free(struct mmlbuf* mmlbuf)
{
    free(mmlbuf);
}

void mmlbuf_reset(struct mmlbuf* mmlbuf)
{
    memset(mmlbuf, 0, sizeof(struct mmlbuf));
    mmlbuf->mml = mmlbuf->buf;
}

char* mmlbuf_buf(struct mmlbuf* mmlbuf)
{
    return mmlbuf->buf;
}

int mmlbuf_append(struct mmlbuf* mmlbuf, char* format, ...)
{
    int ret;
    va_list ap;
    va_start(ap, format);
    ret = mmlbuf_appendv(mmlbuf, format, ap);
    va_end(ap);
    return ret;
}

int mmlbuf_appendv(struct mmlbuf* mmlbuf, char* format, va_list ap)
{
    int ret;
    ret = vsprintf(mmlbuf->mml, format, ap);
    mmlbuf->mml += ret;
    return ret;
}
